/*
    Bantumi
    Copyright 2005, 2006 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Martin Storsj
    martin@martin.st
*/

#import "cocoa.h"

#import <IOBluetoothUI/objc/IOBluetoothDeviceSelectorController.h>
#import <IOBluetooth/objc/IOBluetoothSDPUUID.h>
#import <IOBluetooth/objc/IOBluetoothRFCOMMChannel.h>
#include "connection.h"

class BTConnection;

@interface BluetoothController : NSObject {
	IBOutlet id connectingLabel;
	IBOutlet id waitingLabel;
	IBOutlet id window;
	IBOutlet id progress;

	NSNib *nib;

	BOOL cancelling;
	BOOL opened;
	BluetoothSDPServiceRecordHandle recordHandle;
	IOBluetoothUserNotification *notification;
	IOBluetoothDevice *device;
@public
	IOBluetoothSDPUUID *uuid;
	IOBluetoothRFCOMMChannel *channel;
	BTConnection *conn;
	BOOL released;
	BOOL closed;
}
- (id) init;
- (void) shutdown;
- (void) dealloc;
- (IBAction) cancel: (id) sender;
- (void) sheetDidEnd: (IOBluetoothDeviceSelectorController*) alert returnCode: (int) returnCode contextInfo: (void*) contextInfo;

- (void) rfcommChannelOpenComplete: (IOBluetoothRFCOMMChannel*) chan status: (IOReturn) error;
- (void) rfcommChannelData: (IOBluetoothRFCOMMChannel*) rfcommChannel data: (void*) dataPointer length: (size_t) dataLength;
- (void) rfcommChannelClosed: (IOBluetoothRFCOMMChannel*) rfcommChannel;

- (void) channelOpened: (IOBluetoothUserNotification*) notification channel: (IOBluetoothRFCOMMChannel*) channel;
- (void) connect;
- (void) accept;

- (void) postEmptyEvent;
@end


